#include <stdio.h>
#include <egb.h>
#include <stdlib.h>
#include <string.h>
#include <spr.h>
#include <snd.h>

#define MES_FRAME	15
#define MES_BACK	11

#define UP		0
#define DOWN	1
#define LEFT	2
#define RIGHT	3
#define TR_A	4
#define TR_B	5
#define RUN		6
#define SELECT	7

#define DIR_RIGHT	0
#define DIR_LEFT	1
#define WALK1		0
#define WALK2		1
#define WALK3		2
#define WALK4		3
#define JUMP		4
#define LOW			5

#define JUMP_HIGHT	1
#define STAGEMAX	40
#define LEVELMAX	20
#define OBJMAX		50
#define PARTS_MAX	21
#define PALMAX		40

#define HIGH_TALL	4
#define LOW_TALL	2

#define MANSPR 1020
#define Gwork 1536 /* EGB[NTCY */
#define GbufSize 153600 /* 16F1ʂ̗̈ */
#define Windowbuf 30000 /* window̃obt@ */

#define MUS_OPEN 2
#define MUS_TOWN 1
#define MUS_CAVE 1
#define MUS_END  3

extern char GWork[];

extern char para[];

extern int Myx;
extern int Myy;
extern int SpriteCnt;

extern short int PartsBuf[][16*2];

extern short int Palette[];

extern short int PalBuf[][16];

typedef struct {
	int LeftRegion;
	int RightRegion;
} MAP;

extern MAP regionmap[];

/*************** dfap\̌^錾 ***************/

typedef struct {
	short int x1;
	short int y1;
	short int x2;
	short int y2;
} BOX;

typedef struct {
	short int x;
	short int y;
	short int r;
} CIRCLE;

typedef struct {
	short int no;
	short int x1;
	short int y1;
	short int x2;
	short int y2;
} LINE;

typedef struct {
	short int x;
	short int y;
	short int x1;
	short int y1;
	short int x2;
	short int y2;
	short int r;
} ARC;

typedef struct {
	char *addr;
	short int select;
	short int x1;
	short int y1;
	short int x2;
	short int y2;
} GETPUT;

typedef struct {
	int seqno;
	char blue;
	char red;
	char green;
	char dummy;
} COL;

typedef struct {
	int no;
	COL color[16];
} PALETTE;

typedef struct {
	short int x;
	short int y;
	short int len;
	char str[80];
} STRING;

typedef struct {
	short int x1;
	short int y1;
	short int x2;
	short int y2;
} SCROLL;

typedef struct {
	int pattern; /* XvCgp^[ԍ */
	int sprite; /* XvCgԍ */
	int xsize; /* ̃XvCg */
	int ysize; /* c̃XvCg */
} INFO;

extern INFO CharInfo[][6];

typedef struct {
		int x,y; /* ̃IuWFNg݂XW,YW */
		int region; /* ǂ̃[Wɑ݂邩 */
		int ptn_no; /* p^[io[ */
		int reg_chg; /* ڂ郊[Wio[ 99Ȃړs */
		int level_up; /* xAbv邩 */
		int mes_no; /* bZ[Wo͂̉ */
		int mes_col[10]; /* bZ[Wo͎̐F */
		char *message[10]; /* ̃IuWFNg郁bZ[W */
		int phase;
} OBJECT;

extern OBJECT objlist[LEVELMAX][OBJMAX];

typedef struct {
	char *fname;
	int xsize;
	int ysize;
	int ptn_no;
	int pal;
} PTNINFO;


extern PTNINFO PtnInfo[];



extern int region;
extern int level;

extern char *ScreenMap[STAGEMAX];

extern int WaitCnt;

extern int MusicFlag;
extern int NowMusic;
extern int MusicTable[];

extern void mesinit1();
extern void mesinit2();
extern void mesinit3();
extern void mesinit4();
extern void mapset1();
extern void mapset2();
extern void TransData();
extern int  Help();
